<script setup lang="ts">
import { Milkdown, useEditor } from "@milkdown/vue";
import { Crepe } from "@milkdown/crepe";
import "@milkdown/crepe/theme/common/style.css";
import "@milkdown/crepe/theme/frame.css";

// ----------------------------------------------------------------
// Props
// ----------------------------------------------------------------

const props = defineProps({
  readonly: {
    type: Boolean,
    default: true,
  },
});

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------
const modelValue = defineModel<string>();

useEditor((root) => {
  const crepe = new Crepe({
    root,
    defaultValue: modelValue.value || "",
    featureConfigs: {
      [Crepe.Feature.Placeholder]: {
        text: "No description",
        mode: "doc",
      },
    },
  });
  crepe.on((listener) => {
    listener.markdownUpdated((ctx, markdown, prevMarkdown) => {
      if (markdown !== prevMarkdown) {
        modelValue.value = markdown;
      }
    });
    // https://milkdown.dev/docs/api/plugin-listener
    //   listener.updated(onDocUpdated);
    //   listener.focus(onFocus);
    //   listener.blur(onBlur);
  });
  crepe.setReadonly(props.readonly);

  return crepe;
});
</script>

<template>
  <Milkdown />
</template>

<style>
.milkdown milkdown-slash-menu {
  z-index: 1100;
}
.milkdown milkdown-toolbar {
  z-index: 1100;
}

milkdown-latex-inline-edit {
  z-index: 1100;
}

.milkdown milkdown-link-edit {
  z-index: 1100 !important;
}

.milkdown .ProseMirror {
  padding: 0px 70px;
  margin-bottom: 20px;
}
.milkdown span[data-type="math_inline"] {
  max-width: 100%;
  overflow-y: auto;
}
</style>
